SystemOrganization addCategory: #'Voyage-Memory-Core'!

VORepository subclass: #VOMemoryRepository
	instanceVariableNames: 'objectMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Voyage-Memory-Core'!

!VOMemoryRepository methodsFor: 'persistence' stamp: 'EL 7/3/2008 08:47'!
commit: aBlock
	aBlock value! !

!VOMemoryRepository methodsFor: 'initialization' stamp: 'EL 7/3/2008 08:47'!
initialize
	super initialize.
	objectMap := Dictionary new.! !

!VOMemoryRepository methodsFor: 'testing' stamp: 'EstebanLorenzano 11/2/2010 16:58'!
isNew: anObject 
	^((self list: anObject class) includes: anObject) not.! !

!VOMemoryRepository methodsFor: 'private' stamp: 'EL 6/5/2009 16:50'!
list: aClass
	^objectMap 
		at: aClass persistentClass name 
		ifAbsentPut: [ Set new ]! !

!VOMemoryRepository methodsFor: 'private' stamp: 'JJE 6/6/2009 16:42'!
listOf: aClass
	| objectSet |
	objectSet := self list: aClass.
	^aClass = aClass persistentClass
		ifTrue: [ objectSet ]
		ifFalse: [ objectSet select: [ :each | each isKindOf: aClass] ]
! !

!VOMemoryRepository methodsFor: 'private' stamp: 'EstebanLorenzano 12/29/2010 18:29'!
objectMap 
	^objectMap! !

!VOMemoryRepository methodsFor: 'private' stamp: 'EstebanLorenzano 12/29/2010 18:29'!
objectMap: aDictionary
	objectMap := aDictionary! !

!VOMemoryRepository methodsFor: 'persistence' stamp: 'EstebanLorenzano 2/23/2011 18:11'!
remove: anObject
	^(self list: anObject class) 
		remove: anObject
		ifAbsent: [ "Do nothing" ]! !

!VOMemoryRepository methodsFor: 'persistence' stamp: 'EstebanLorenzano 2/23/2011 18:11'!
removeAll: aClass 
	objectMap 
		removeKey: aClass persistentClass name 
		ifAbsent: [ "Do nothing" ]	! !

!VOMemoryRepository methodsFor: 'persistence' stamp: 'JJE 6/6/2009 16:42'!
save: anObject
	^(self list: anObject class) add: anObject.! !

!VOMemoryRepository methodsFor: 'persistence' stamp: 'EL 6/5/2009 16:51'!
selectAll: aClass
	^self listOf: aClass ! !

!VOMemoryRepository methodsFor: 'persistence' stamp: 'EstebanLorenzano 10/29/2009 10:37'!
selectAll: aClass sortBy: sortBlock
	^sortBlock
		ifNotNil: [ (self listOf: aClass) sortBy: sortBlock ] 
		ifNil: [ self listOf: aClass ]! !

!VOMemoryRepository methodsFor: 'persistence' stamp: 'EL 6/5/2009 16:51'!
selectMany: aClass where: aBlock
	^(self listOf: aClass) select: aBlock! !

!VOMemoryRepository methodsFor: 'persistence' stamp: 'EstebanLorenzano 10/29/2009 10:50'!
selectMany: aClass where: aBlock sortBy: sortBlock
	^sortBlock 
		ifNotNil: [ (((self listOf: aClass) select: aBlock) asSortedCollection: sortBlock) asOrderedCollection ]
		ifNil: [ (self listOf: aClass) select: aBlock ]! !

!VOMemoryRepository methodsFor: 'persistence' stamp: 'EL 6/5/2009 16:51'!
selectOne: aClass where: aBlock
	^(self listOf: aClass) detect: aBlock ifNone: [ nil ]! !
